'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _rest = require('./rest');

var _searchProviders = require('./search-providers');

var _searchProviders2 = _interopRequireDefault(_searchProviders);

var Paging = (function () {
  function Paging(opt) {
    _classCallCheck(this, Paging);

    this.opt = opt;

    var SearchProvider = _searchProviders2['default'][opt.queryBuilderType];
    if (!SearchProvider) {
      throw new Error('Invalid query builder type: ' + opt.queryBuilderType + '.');
    }

    this.searchProvider = new SearchProvider(opt);
    this.opt.sortFieldName = this.searchProvider.sortFieldName;
  }

  _createClass(Paging, [{
    key: 'addSortDbQuery',
    value: function addSortDbQuery(queryBuilder) {
      this.searchProvider.addPagingQuery(queryBuilder);
    }
  }, {
    key: 'buildPagingResult',
    value: function buildPagingResult(data) {
      var dataResult = Array.isArray(data) ? data : [];

      this.opt.data = { list: dataResult };

      if (!this.opt.data.list.length) return this.opt.data;

      if (!this.searchProvider.isForwardPagging) this.opt.data.list.reverse();

      (0, _rest.datePaged)(this.opt);

      return this.opt.data;
    }
  }, {
    key: 'getSortQuery',
    value: function getSortQuery(primaryField) {
      return this.searchProvider.getSortQuery(primaryField);
    }
  }, {
    key: 'getLimitQuery',
    value: function getLimitQuery() {
      // use limit + 1 due paging
      return this.opt.limit + 1;
    }
  }, {
    key: 'addSelfLink',
    value: function addSelfLink(data, id, root) {
      var _id = id || this.opt.idField;
      var _root = root || this.opt.root;

      (0, _rest.addSelfLink)(data, _id, _root);
    }
  }, {
    key: 'addSelfLinkInAllItems',
    value: function addSelfLinkInAllItems(data, id, root) {
      var _id = id || this.opt.idField;
      var _root = root || this.opt.root;

      data.list.forEach(function (item) {
        return (0, _rest.addSelfLink)(item, _id, _root);
      });
    }
  }]);

  return Paging;
})();

exports['default'] = Paging;
module.exports = exports['default'];