'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _searchProvider = require('./search-provider');

var _searchProvider2 = _interopRequireDefault(_searchProvider);

var MongooseSearchProvider = (function (_SearchProvider) {
  function MongooseSearchProvider(opt) {
    _classCallCheck(this, MongooseSearchProvider);

    _get(Object.getPrototypeOf(MongooseSearchProvider.prototype), 'constructor', this).call(this, opt);
  }

  _inherits(MongooseSearchProvider, _SearchProvider);

  _createClass(MongooseSearchProvider, [{
    key: 'getSortQuery',
    value: function getSortQuery(primaryField) {
      var field = primaryField || this.sortFieldColumn;
      var sortDirection = this.isAscQuerySort ? '' : '-';

      return '' + sortDirection + field + ' ' + sortDirection + this.idFieldColumn;
    }
  }, {
    key: 'addPagingQuery',
    value: function addPagingQuery(dbQuery) {
      var sortFilter = this._buildPagingQuery();

      dbQuery.and(sortFilter);
    }
  }, {
    key: '_buildPagingQuery',
    value: function _buildPagingQuery() {
      var sortFilter = {};
      if (!this.hasParametersToFilter()) return sortFilter;

      var offsetAndIdQuery = this._buildOffsetAndIdQuery();

      if (this.isAscQuerySort) {
        var greaterThanOffsetDate = this._getQueryGreaterThanOffset();

        sortFilter.$or = [greaterThanOffsetDate, offsetAndIdQuery];
      } else {
        var lessThanOffsetDate = this._getQueryLessThanOffset();

        sortFilter.$or = [lessThanOffsetDate, offsetAndIdQuery];
      }

      sortFilter[this.idFieldColumn] = { $ne: this.query.offset_id };

      return sortFilter;
    }
  }, {
    key: '_buildOffsetAndIdQuery',
    value: function _buildOffsetAndIdQuery() {
      var equalOffsetDate = this._getQueryEqualOffset();

      var andId = {};

      if (this.isAscQuerySort) {
        andId[this.idFieldColumn] = { $gt: this.query.offset_id };
      } else {
        andId[this.idFieldColumn] = { $lt: this.query.offset_id };
      }

      return { $and: [equalOffsetDate, andId] };
    }
  }, {
    key: '_getQueryEqualOffset',
    value: function _getQueryEqualOffset() {
      var query = {};
      query[this.sortFieldColumn] = this.offsetPrimaryField;
      return query;
    }
  }, {
    key: '_getQueryGreaterThanOffset',
    value: function _getQueryGreaterThanOffset() {
      var query = {};
      query[this.sortFieldColumn] = { $gt: this.offsetPrimaryField };
      return query;
    }
  }, {
    key: '_getQueryLessThanOffset',
    value: function _getQueryLessThanOffset() {
      var query = {};
      query[this.sortFieldColumn] = { $lt: this.offsetPrimaryField };
      return query;
    }
  }]);

  return MongooseSearchProvider;
})(_searchProvider2['default']);

exports['default'] = MongooseSearchProvider;
module.exports = exports['default'];