'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var ISODateRegexPattern = /^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.{0,4}Z$/;

var DIRECTION = {
  FORWARD: 'forward',
  BACKWARD: 'backward'
};

exports.DIRECTION = DIRECTION;

var SearchProvider = (function () {
  function SearchProvider(opt) {
    _classCallCheck(this, SearchProvider);

    this.query = opt.query;

    this.sortField = opt.query.sort || opt.defaultSortField;
    this.sortFieldName = this.sortField.json || this.sortField;
    this.isSortDesc = /^-/.test(this.sortField.column || this.sortFieldName);
    this.isForwardPagging = opt.query.dir !== DIRECTION.BACKWARD;
    this.isAscQuerySort = !this.isSortDesc && this.isForwardPagging || this.isSortDesc && !this.isForwardPagging;
    this.sortFieldColumn = (this.sortField.column || this.sortFieldName).replace(/^-/, '');
    this.offsetPrimaryField = getOffsetValue(this.query);
    this.idField = opt.idField;
    this.idFieldColumn = opt.idField.column || opt.idField;
  }

  _createClass(SearchProvider, [{
    key: 'hasParametersToFilter',
    value: function hasParametersToFilter() {
      return this.offsetPrimaryField && this.query.offset_id;
    }
  }, {
    key: 'addPagingQuery',

    /* required public API to all providers */
    value: function addPagingQuery() {}
  }, {
    key: 'getSortQuery',
    value: function getSortQuery() {}
  }]);

  return SearchProvider;
})();

exports['default'] = SearchProvider;

function getOffsetValue(query) {
  if (ISODateRegexPattern.test(query.offset_date)) return query.offset_date;

  var value = parseInt(query.offset_sort, 10);
  if (!isNaN(value)) return value;

  return query.offset_sort;
}